/*  PENCERE KOY - TOP KOY - VUR  */

#include <windows.h>											// Header File For Windows
#include <gl\gl.h>												// Header File For The OpenGL32 Library
#include <gl\glu.h>												// Header File For The GLu32 Library
#include <gl\glaux.h>											// Header File For The GLaux Library
#include "NeHeGL.h"												// Header File For NeHeGL
#include "resource.h"											// Header File For Resource (*IMPORTANT*)
#include <stdio.h>
#include <math.h>
#include <vfw.h>

#define MAX_FILE_NUM	15
#define MAX_POINT_NUM	5000
#define MAX_QUADR_NUM	5000

#pragma comment( lib, "opengl32.lib" )							// Search For OpenGL32.lib While Linking
#pragma comment( lib, "glu32.lib" )								// Search For GLu32.lib While Linking
#pragma comment( lib, "glaux.lib" )								// Search For GLaux.lib While Linking
#pragma comment( lib, "vfw32.lib" )

#ifndef CDS_FULLSCREEN											// CDS_FULLSCREEN Is Not Defined By Some
#define CDS_FULLSCREEN 4										// Compilers. By Defining It This Way,
#endif															// We Can Avoid Errors

GL_Window*	g_window;
Keys*		g_keys;


GLuint texture[MAX_FILE_NUM];												// Storage For 3 Textures

int fileNo = 0;
int pointNo = 0;
int quadraticNo = 0;
BOOL rising = FALSE, risingPressed = FALSE;
BOOL onTheDoor = FALSE;
BOOL help = FALSE;
BOOL jump = FALSE;
float jumper;
float jumperAcc;

float myX = 0.0f, myY = 0.0f, myZ = 0.0f;
float rotX, rotZ;
float alpha = 0.0f, beta = 0.0f, tetha = 0.0f;

float lastX, lastY, lastZ;

int					next;
int					frame=0;
AVISTREAMINFO		psi;										// Pointer To A Structure Containing Stream Info
PAVISTREAM			pavi;										// Handle To An Open Stream
PGETFRAME			pgf;										// Pointer To A GetFrame Object
BITMAPINFOHEADER	bmih;										// Header Information For DrawDibDraw Decoding
long				lastframe;									// Last Frame Of The Stream
int					width;										// Video Width
int					height;										// Video Height
char				*pdata;										// Pointer To Texture Data
int					mpf;										// Will Hold Rough Milliseconds Per Frame

GLUquadricObj *quadratic;										// Storage For Our Quadratic Objects

HDRAWDIB hdd;													// Handle For Our Dib
HBITMAP hBitmap;												// Handle To A Device Dependant Bitmap
HDC hdc = CreateCompatibleDC(0);								// Creates A Compatible Device Context
unsigned char* data = 0;


int numOfPoints[MAX_FILE_NUM];
struct Points{
	float x, y, z;
};

struct Points myPoints[MAX_POINT_NUM];
int numOfQuadratics[MAX_FILE_NUM];

struct Quadratics{
	int a, b, c;
};

struct Quadratics myQuadratics[MAX_QUADR_NUM];







void flipIt(void* buffer)										// Flips The Red And Blue Bytes (256x256)
{
	void* b = buffer;											// Pointer To The Buffer
	__asm														// Assembler Code To Follow
	{
		mov ecx, 256*256										// Counter Set To Dimensions Of Our Memory Block
		mov ebx, b												// Points ebx To Our Data (b)
		label:													// Label Used For Looping
			mov al,[ebx+0]										// Loads Value At ebx Into al
			mov ah,[ebx+2]										// Loads Value At ebx+2 Into ah
			mov [ebx+2],al										// Stores Value In al At ebx+2
			mov [ebx+0],ah										// Stores Value In ah At ebx
			
			add ebx,3											// Moves Through The Data By 3 Bytes
			dec ecx												// Decreases Our Loop Counter
			jnz label											// If Not Zero Jump Back To Label
	}
}

void OpenAVI(LPCSTR szFile)										// Opens An AVI File (szFile)
{
	TCHAR	title[100];											// Will Hold The Modified Window Title

	AVIFileInit();												// Opens The AVIFile Library

	// Opens The AVI Stream
	if (AVIStreamOpenFromFile(&pavi, szFile, streamtypeVIDEO, 0, OF_READ, NULL) !=0)
	{
		// An Error Occurred Opening The Stream
		MessageBox (HWND_DESKTOP, "Failed To Open The AVI Stream", "Error", MB_OK | MB_ICONEXCLAMATION);
	}

	AVIStreamInfo(pavi, &psi, sizeof(psi));						// Reads Information About The Stream Into psi
	width=psi.rcFrame.right-psi.rcFrame.left;					// Width Is Right Side Of Frame Minus Left
	height=psi.rcFrame.bottom-psi.rcFrame.top;					// Height Is Bottom Of Frame Minus Top

	lastframe=AVIStreamLength(pavi);							// The Last Frame Of The Stream

	mpf=AVIStreamSampleToTime(pavi,lastframe)/lastframe;		// Calculate Rough Milliseconds Per Frame

	bmih.biSize = sizeof (BITMAPINFOHEADER);					// Size Of The BitmapInfoHeader
	bmih.biPlanes = 1;											// Bitplanes	
	bmih.biBitCount = 24;										// Bits Format We Want (24 Bit, 3 Bytes)
	bmih.biWidth = 256;											// Width We Want (256 Pixels)
	bmih.biHeight = 256;										// Height We Want (256 Pixels)
	bmih.biCompression = BI_RGB;								// Requested Mode = RGB

	hBitmap = CreateDIBSection (hdc, (BITMAPINFO*)(&bmih), DIB_RGB_COLORS, (void**)(&data), NULL, NULL);
	SelectObject (hdc, hBitmap);								// Select hBitmap Into Our Device Context (hdc)

	pgf=AVIStreamGetFrameOpen(pavi, NULL);						// Create The PGETFRAME	Using Our Request Mode
	if (pgf==NULL)
	{
		// An Error Occurred Opening The Frame
		MessageBox (HWND_DESKTOP, "Failed To Open The AVI Frame", "Error", MB_OK | MB_ICONEXCLAMATION);
	}

	// Information For The Title Bar (Width / Height / Last Frame)
	wsprintf (title, "Computer Graphics Project [Beycan - Hasan - pek]");
	SetWindowText(g_window->hWnd, title);						// Modify The Title Bar
}

void GrabAVIFrame(int frame)									// Grabs A Frame From The Stream
{
	LPBITMAPINFOHEADER lpbi;									// Holds The Bitmap Header Information
	lpbi = (LPBITMAPINFOHEADER)AVIStreamGetFrame(pgf, frame);	// Grab Data From The AVI Stream
	pdata=(char *)lpbi+lpbi->biSize+lpbi->biClrUsed * sizeof(RGBQUAD);	// Pointer To Data Returned By AVIStreamGetFrame

	// Convert Data To Requested Bitmap Format
	DrawDibDraw (hdd, hdc, 0, 0, 256, 256, lpbi, pdata, 0, 0, width, height, 0);

	flipIt(data);												// Swap The Red And Blue Bytes (GL Compatability)

	// Update The Texture
	glTexSubImage2D (GL_TEXTURE_2D, 0, 0, 0, 256, 256, GL_RGB, GL_UNSIGNED_BYTE, data);
}

void CloseAVI(void)												// Properly Closes The Avi File
{
	DeleteObject(hBitmap);										// Delete The Device Dependant Bitmap Object
	DrawDibClose(hdd);											// Closes The DrawDib Device Context
	AVIStreamGetFrameClose(pgf);								// Deallocates The GetFrame Resources
	AVIStreamRelease(pavi);										// Release The Stream
	AVIFileExit();												// Release The File
}



void ReadDataFromFile(char *file){
	FILE *f;
	int i;
	float mx, my, mz;

	f=fopen(file, "r");

	if(f){
		fscanf(f, "%f %f %f\n", &mx, &my, &mz);

		fscanf(f, "%d\n", &(numOfPoints[fileNo]) );
		for(i=0; i<numOfPoints[fileNo]; ++i){
			fscanf(f, "%f %f %f\n", &(myPoints[pointNo].x), &(myPoints[pointNo].y), &(myPoints[pointNo].z));
			myPoints[pointNo].x *= mx;
			myPoints[pointNo].y *= my;
			myPoints[pointNo].z *= mz;
			++pointNo;
		}

		fscanf(f, "%d\n", &(numOfQuadratics[fileNo]));
		for(i=0; i<numOfQuadratics[fileNo]; ++i)
			fscanf(f, "%d %d %d\n", &(myQuadratics[quadraticNo].a), &(myQuadratics[quadraticNo].b), 
							&(myQuadratics[quadraticNo++].c) );
		fclose(f);
		++fileNo;
	}
}

void LoadGLTextures()											// Creates Textures From Bitmaps In The Resource File
{
	HBITMAP hBMP;												// Handle Of The Bitmap
	BITMAP	BMP;												// Bitmap Structure

	// The ID Of The 3 Bitmap Images We Want To Load From The Resource File
	byte	Texture[]={	IDB_DESERT,	IDB_GRASS, IDB_BRICK4, IDB_BRICK2, IDB_MERMER, IDB_TV, IDB_GRASS, IDB_ROCK, IDB_ENVIRONMENT, IDB_TOP, IDB_ROCK, IDB_WATER, IDB_BRICK3, IDB_HELP, IDB_BRICK1, IDB_BRICK1 };

	glGenTextures(sizeof(Texture), &texture[0]);				// Generate 3 Textures (sizeof(Texture)=3 ID's)
	for (int loop=0; loop<sizeof(Texture); loop++)				// Loop Through All The ID's (Bitmap Images)
	{
		hBMP=(HBITMAP)LoadImage(GetModuleHandle(NULL),MAKEINTRESOURCE(Texture[loop]), IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION);
		if (hBMP)												// Does The Bitmap Exist?
		{														// If So...
			GetObject(hBMP,sizeof(BMP), &BMP);					// Get The Object
																// hBMP: Handle To Graphics Object
																// sizeof(BMP): Size Of Buffer For Object Information
																// Buffer For Object Information
			glPixelStorei(GL_UNPACK_ALIGNMENT,4);				// Pixel Storage Mode (Word Alignment / 4 Bytes)
			glBindTexture(GL_TEXTURE_2D, texture[loop]);		// Bind Our Texture
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);	// Linear Filtering
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR); // Mipmap Linear Filtering

			// Generate Mipmapped Texture (3 Bytes, Width, Height And Data From The BMP)
			gluBuild2DMipmaps(GL_TEXTURE_2D, 3, BMP.bmWidth, BMP.bmHeight, GL_BGR_EXT, GL_UNSIGNED_BYTE, BMP.bmBits);
			DeleteObject(hBMP);									// Delete The Bitmap Object
		}
	}
}

BOOL Initialize (GL_Window* window, Keys* keys)					// Any GL Init Code & User Initialiazation Goes Here
{
	g_window	= window;
	g_keys		= keys;

	LoadGLTextures();											// Load The Textures From Our Resource File

	hdd = DrawDibOpen();										// Grab A Device Context For Our Dib

	ReadDataFromFile("Data/desert.txt");
	ReadDataFromFile("Data/grass.txt");
	ReadDataFromFile("Data/house.txt");
	ReadDataFromFile("Data/roof.txt");
	ReadDataFromFile("Data/marble.txt");
	ReadDataFromFile("Data/TV.txt");
	ReadDataFromFile("Data/tree.txt");
	ReadDataFromFile("Data/treeDown.txt");
	ReadDataFromFile("Data/environment.txt");
	ReadDataFromFile("Data/clouds.txt");
	ReadDataFromFile("Data/unnecessary.txt");
	ReadDataFromFile("Data/bigball.txt");
	ReadDataFromFile("Data/ball.txt");
	ReadDataFromFile("Data/ball.txt");


	glClearColor (0.4f, 0.5f, 0.9f, 1.0f);						// Black Background
	glClearDepth (1.0f);										// Depth Buffer Setup
	glDepthFunc (GL_LEQUAL);									// The Type Of Depth Testing (Less Or Equal)
	//glDisable(GL_DEPTH_TEST);									// Disable Depth Testing
	glEnable(GL_DEPTH_TEST);
	glShadeModel (GL_SMOOTH);									// Select Smooth Shading
	glHint (GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);			// Set Perspective Calculations To Most Accurate
	glEnable(GL_TEXTURE_2D);									// Enable Texture Mapping
	//glBlendFunc(GL_ONE,GL_SRC_ALPHA);							// Set Blending Mode (Cheap / Quick)
	//glEnable(GL_BLEND);											// Enable Blending


	quadratic=gluNewQuadric();									// Create A Pointer To The Quadric Object
	gluQuadricNormals(quadratic, GLU_SMOOTH);					// Create Smooth Normals 
	gluQuadricTexture(quadratic, GL_TRUE);						// Create Texture Coords 

	glEnable(GL_TEXTURE_2D);									// Enable Texture Mapping
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);	// Set Texture Max Filter
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);	// Set Texture Min Filter

	glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);		// Set The Texture Generation Mode For S To Sphere Mapping
	glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);		// Set The Texture Generation Mode For T To Sphere Mapping

	OpenAVI("Data/Face2.avi");									// Open The AVI File

	// Create The Texture

	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, 256, 256, 0, GL_RGB, GL_UNSIGNED_BYTE, data);

	return TRUE;
}

void Deinitialize (void)
{
	CloseAVI();	
}

void Update (DWORD milliseconds)
{
	if (g_keys->keyDown [VK_ESCAPE] == TRUE)
	{
		TerminateApplication (g_window);
	}

	help = FALSE;
	if (g_keys->keyDown [VK_F1] == TRUE && !help)
	{
		help = TRUE;
		//ToggleFullscreen (g_window);
	}


	lastX = myX;
	lastY = myY;
	lastZ = myZ;

	if (g_keys->keyDown ['W'] == TRUE || g_keys->keyDown [VK_UP] )
	{
		myX -= sin(alpha)*0.2f;
		myZ -= cos(alpha)*0.2f;
		tetha += 0.2;
	}

	if (g_keys->keyDown ['S'] == TRUE || g_keys->keyDown [VK_DOWN] )
	{
		myX += sin(alpha)*0.2f;
		myZ += cos(alpha)*0.2f;
		tetha += 0.2;
	}
	if (g_keys->keyDown ['X'] == TRUE)
	{
		myX += cos(alpha)*0.3f;
		myZ -= sin(alpha)*0.3f;
		tetha += 0.2;
	}

	if (g_keys->keyDown ['Z'] == TRUE)
	{
		myX -= cos(alpha)*0.3f;
		myZ += sin(alpha)*0.3f;
		tetha += 0.2;
	}
	if (g_keys->keyDown ['R'] == TRUE)
	{
		myY += 0.1f;
	}
	if (g_keys->keyDown ['F'] == TRUE)
	{
		myY -= 0.1f;
	}

	if (g_keys->keyDown ['U'] == TRUE && !risingPressed)
	{
		rising = !rising;
		risingPressed = TRUE;
	}
	if(!g_keys->keyDown ['U'])
		risingPressed = FALSE;
	
	if(!rising)
		myY = 0.1*sin(tetha)+0.1;

	
	if (g_keys->keyDown ['A'] == TRUE || g_keys->keyDown [VK_LEFT] )
	{
		alpha += 0.03f;
	}

	if (g_keys->keyDown ['D'] == TRUE || g_keys->keyDown [VK_RIGHT] )
	{
		alpha -= 0.03f;
	}

	if (g_keys->keyDown [' '] == TRUE && !jump)
	{
		jump = TRUE;
		jumper = 0.0f;
		jumperAcc = 0.5f;
	}
	if(jump){
		jumper += jumperAcc;
		jumperAcc -= 0.03f;
		if (jumperAcc < -0.5f)
			jump = FALSE;
	}

	onTheDoor = FALSE;
	// on the door
	if(fabs(lastX) < 2 && lastZ < -17 && lastZ > -23 && lastY > -0.2 && lastY < 4){
		onTheDoor = TRUE;
	}
	// inside the house
	if(fabs(lastX) < 18.5 && fabs(lastZ) < 18.5 && fabs(lastY) < 7 && lastY > -0.2 && !onTheDoor){
		if(fabs(lastX) < 18.5 && fabs(myX) > 18.5)
			myX = lastX;
		if(fabs(lastZ) < 18.5 && fabs(myZ) > 18.5)
			myZ = lastZ;
		if(fabs(lastY) < 7 && fabs(myY) > 7)
			myY = lastY;
		if(lastY > -0.2 && myY < -0.2)
			myY = lastY;
	}

	// outside the house
	else if(!onTheDoor && (fabs(lastX) > 21.5 || fabs(lastZ) > 21.5 || fabs(lastY) > 7 || lastY < -0.2)){
		if(fabs(lastX) > 21.5 && fabs(myX) < 21.5 && fabs(myZ) < 21.5)
			myX = lastX;
		if(fabs(lastZ) > 21.5 && fabs(myZ) < 21.5 && fabs(myX) < 21.5)
			myZ = lastZ;
		if(fabs(lastY) > 7 && fabs(myY) < 7 && fabs(myX) < 21.5 && fabs(myZ) < 21.5)
			myY = lastY;
		if(lastY < -0.2 && myY > -0.2 && fabs(myX) < 21.5 && fabs(myZ) < 21.5)
			myY = lastY;
	}

	// error solving
	else
	{

		
		if(!onTheDoor && fabs(myX) < 21.5 &&  fabs(myX) > 18.5)
			myX += fabs(myX) > 20 ? myX*0.01 : -myX*0.01;
		if(!onTheDoor && fabs(myZ) < 21.5 &&  fabs(myZ) > 18.5)
			myZ += fabs(myZ) > 20 ? myZ*0.01 : -myZ*0.01;

	}

	// near the world and moon
	if(fabs(lastX) > 2 && fabs(myX) < 2 && fabs(lastZ+5) < 2 && fabs(lastY-2.5) < 2.7){
		myX = lastX;
	}
	if(fabs(lastX) < 2 && fabs(lastZ+5) > 2 && fabs(myZ+5) < 2 && fabs(lastY-2.5) < 2.7){
		myZ = lastZ;
	}
	if(fabs(lastX) < 2 && fabs(lastZ+5) < 2 && fabs(lastY-2.5) < 2.7 && fabs(myY-2.5) > 2.7){
		myY = lastY;
	}

	// near the trees
	if(fabs(fabs(lastX) - 30) > 2 && fabs(fabs(myX) - 30) < 2 && fabs(fabs(lastZ) - 30) < 2){
		myX = lastX;
	}
	if(fabs(fabs(lastZ) - 30) > 2 && fabs(fabs(myZ) - 30) < 2 && fabs(fabs(lastX) - 30) < 2){
		myZ = lastZ;
	}

	// near the wall
	if(fabs(lastX) < 98 && fabs(myX) > 98)
		myX = lastX;
	if(fabs(lastZ) < 98 && fabs(myZ) > 98)
		myZ = lastZ;


	next+=milliseconds;											// Increase next Based On The Timer
	frame=next/mpf;												// Calculate The Current Frame

	if (frame>=lastframe)										// Are We At Or Past The Last Frame?
	{
		frame=0;												// Reset The Frame Back To Zero (Start Of Video)
		next=0;													// Reset The Animation Timer (next)
	}
}

void Draw (void)
{
	int i, ii, j=0, pNext = 0;
	glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glLoadIdentity ();
	glMatrixMode(GL_MODELVIEW);
	glEnable(GL_DEPTH_TEST);

	rotX = sin(alpha);
	rotZ = cos(alpha);
	gluLookAt(myX,myY + jumper,myZ, myX-rotX,myY + jumper,myZ-rotZ, 0.0f,1.0f,0.0f);
	beta += 0.5f;

	for(ii=0; ii<11; ii++){
		glBindTexture(GL_TEXTURE_2D, texture[ii]);

		glBegin(GL_TRIANGLES); //  GL_QUADS
			for(i=0; i<numOfQuadratics[ii]; i++)
			{
				glTexCoord2f(1.0f,1.0f); glVertex3f( myPoints[myQuadratics[j].a + pNext].x, myPoints[myQuadratics[j].a + pNext].y, myPoints[myQuadratics[j].a + pNext].z);	
				if(i%2) glTexCoord2f(0.0f,0.0f); else glTexCoord2f(0.0f,1.0f); glVertex3f( myPoints[myQuadratics[j].b + pNext].x, myPoints[myQuadratics[j].b + pNext].y, myPoints[myQuadratics[j].b + pNext].z);
				if(i%2) glTexCoord2f(1.0f,0.0f); else glTexCoord2f(0.0f,0.0f); glVertex3f( myPoints[myQuadratics[j].c + pNext].x, myPoints[myQuadratics[j].c + pNext].y, myPoints[myQuadratics[j++].c + pNext].z);	
			}
		glEnd();

		pNext += numOfPoints[ii];
	}

	glEnable(GL_TEXTURE_2D);									// Enable Texture Mapping
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);	// Set Texture Max Filter
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);


	GrabAVIFrame(frame);										// Grab A Frame From The AVI

		glBegin(GL_QUADS);										// Begin Drawing A Cube
			
			// Front
			glNormal3f(1.0f, 0.0f, 0.0f);
			glTexCoord2f(1.0f, 0.0f); glVertex3f(7.5f, 0.6f, -19.8f);
			glTexCoord2f(0.0f, 0.0f); glVertex3f(4.5f, 0.6f, -19.8f);
			glTexCoord2f(0.0f, 1.0f); glVertex3f(4.5f, 2.4f, -19.8f);
			glTexCoord2f(1.0f, 1.0f); glVertex3f(7.5f, 2.4f, -19.8f);

		
		glEnd();


	for(ii=11; ii<fileNo; ii++){
		glBindTexture(GL_TEXTURE_2D, texture[ii]);
		
		if (ii == 11){
			glTranslatef(0.0f,0.0f,-5.0f);
			glRotatef(3*beta,0,1,0);
		}else if(ii == 12){
			glRotatef(beta,0,1,0);
			glTranslatef(0.0f,0.0f,1.0f);
		}else if(ii == 13){
			glTranslatef(0.0f,0.0f,-1.0f);
			glRotatef(-beta,0,1,0);
			glRotatef(-3*beta,0,1,0);
			glTranslatef(10.0f,0.0f,0.0f);
		}

		glBegin(GL_TRIANGLES); //  GL_QUADS
			for(i=0; i<numOfQuadratics[ii]; i++)
			{
				glTexCoord2f(1.0f,1.0f); glVertex3f( myPoints[myQuadratics[j].a + pNext].x, myPoints[myQuadratics[j].a + pNext].y, myPoints[myQuadratics[j].a + pNext].z);	
				if(i%2) glTexCoord2f(0.0f,0.0f); else glTexCoord2f(0.0f,1.0f); glVertex3f( myPoints[myQuadratics[j].b + pNext].x, myPoints[myQuadratics[j].b + pNext].y, myPoints[myQuadratics[j].b + pNext].z);
				if(i%2) glTexCoord2f(1.0f,0.0f); else glTexCoord2f(0.0f,0.0f); glVertex3f( myPoints[myQuadratics[j].c + pNext].x, myPoints[myQuadratics[j].c + pNext].y, myPoints[myQuadratics[j++].c + pNext].z);	
			}
		glEnd();

		pNext += numOfPoints[ii];
	}

	if(help){
		glLoadIdentity ();
		glDisable(GL_DEPTH_TEST);
		glTranslatef(-1.6f,0.2f,-3.0f);
		glBindTexture(GL_TEXTURE_2D, texture[13]);
			glBegin(GL_QUADS);
				glTexCoord2f(1.0f,1.0f); glVertex3f(1,1,0);	
				glTexCoord2f(1.0f,0.0f); glVertex3f(1,0,0);
				glTexCoord2f(0.0f,0.0f); glVertex3f(0,0,0);
				glTexCoord2f(0.0f,1.0f); glVertex3f(0,1,0);
			glEnd();
	}
	
	Sleep(15);

	glFlush ();
}
